
# Wat

[![Build Status](https://travis-ci.org/dthree/wat.svg)](https://travis-ci.org/dthree/wat) 
[![Coverage Status](https://coveralls.io/repos/dthree/wat/badge.svg?branch=master&service=github)](https://coveralls.io/github/dthree/wat?branch=master)
[![Gitter, Dude](https://img.shields.io/badge/gitter-join%20chat-brightgreen.svg)](https://gitter.im/dthree/wat?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge) 
[![XO: Linted](https://img.shields.io/badge/xo-linted-blue.svg)](https://github.com/sindresorhus/xo)
[![NPM Version](https://img.shields.io/npm/v/wat.svg)](https://www.npmjs.com/package/wat)

> Rebelliously practical docs. For and by the community. Wat.

Finally, community-built cheat sheets for every coder, targeting any framework, in any language. 

At the tip of your fingers.

Wat is an interactive app built to drastically reduce time spent searching for syntax and code usage questions. Wat aggregates project APIs, readmes, code snippits, usage samples and practical documentation across any language or libary, and makes this data ridiculously accessible from the one tool every developer uses: the CLI.

Wat was designed for ease. It takes you:

- [20 seconds to install](#install)
- [5 minutes to master](#learn)
- [15 minutes to contribute](#contribute)

## Contents

- [Introduction](#introduction)
- [Install](#install)
- [Learn](#learn)
- [Contribute](#contribute)
- [What's on Wat](#projects-now-documented-on-wat)
- [FAQ](#faq)
- [License](#license)

Made by [dthree](https://github.com/dthree) with :heart: and a little [secret sauce](https://github.com/dthree/vorpal).

## Introduction

#### Wat is scheduled for imminent release!

Want to contribute and make it happen? [Email me](mailto:threedeecee@gmail.com) or join the [Gitter channel](https://gitter.im/dthree/wat?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge).

Want to try it **right now**?

```bash
$ npm install -g wat
$ wat tour
```

#### Wat covers everything

Wat provides the only community-based, centralized source of syntax cheat sheets for every language and every major framework and library. If it has an API and is used by the community, it's supported here!

#### It's smart

Wat combines indexes, edit-distance algorithms, auto-completion and common sense to make sure you get what you asked for. It auto-updates when the community adds content, and optimizes its performance based on the content you use most.

#### It shreds red tape like a frisky cat

Wat's content is not perfect, it isn't formal and it isn't pedantic. Wat doesn't aim to provide letter-perfect, offical documentation for languages. Work like that [is in good hands](https://developer.mozilla.org/en-US/).

If you're building a web browser, refer to [W3C](http://www.w3.org/) for specifications. Wat is targeted for the 99.99% of us who have the basic familiarity with a library and simply need to look up API or usage samples.

## Install

```bash
npm install -g wat
```
[np-what? Oh, isn't that Node? I don't do Node.](https://github.com/dthree/wat/wiki/FAQ#sorry-i-dont-speak-node)

## Learn

```bash
wat tour
```
## Contribute

Contributing is *easy*!

[Get started here](https://github.com/dthree/wat/wiki/Docs-|-Contributing), and help spread the word! 

Wat is like a giant, friendly snowball that's somehow caught fire. The bigger the community, the better it gets. :snowflake: :fire:

## Future

If Wat gets sufficiently adopted by the community, I'll make a web-based version as well.

Same data, new fancy interface.

## Projects now documented on Wat

[![2 Languages](https://img.shields.io/badge/languages-2-brightgreen.svg)](#)
[![15 Libraries](https://img.shields.io/badge/libraries-15-blue.svg)](#)

##### Languages

> JS (some of it), Node

##### Javascript Libraries

> [D3](https://github.com/mbostock/d3)

##### Node.js Libraries

> [Chalk](https://github.com/sindresorhus/chalk), [debug](https://github.com/visionmedia/debug), [download](https://github.com/kevva/download), [got](https://github.com/sindresorhus/got), [MDAST](https://github.com/wooorm/mdast), [mkdirp](https://github.com/substack/node-mkdirp), [Node HTTP Proxy](https://github.com/nodejitsu/node-http-proxy), [Node Inspector](https://github.com/node-inspector/node-inspector), [Pageres](https://github.com/sindresorhus/pageres), [request](https://github.com/request/request), [RobotJS](https://github.com/octalmage/robotjs), [Screenful](https://github.com/sindresorhus/screenful), [Vantage](https://github.com/dthree/vantage), [Vorpal](https://github.com/dthree/vorpal)

## FAQ

- [Sorry, I don't speak Node](https://github.com/dthree/wat/wiki/FAQ#sorry-i-dont-speak-node)
- [How does Wat relate to Dash?](https://github.com/dthree/wat/wiki/FAQ#how-does-wat-relate-to-dash)

## Why Wat?

Because **wat** is forgetting the syntax to splice an Array for the 10th time.

Because **wat** is having to search `js splice an array`, sift through [W3Schools](http://www.w3fools.com/) and [MSDN](https://msdn.microsoft.com/en-US/) results, `Command + Click` three [Stack Overflow](http://stackoverflow.com/) tabs, close the first one, digest the second and then scroll to the answer to remember... again.

Because I would rather just type:

`wat js array splice`

## License

MIT
